﻿@page "/competitionParents/create"
@page "/competitionParents/edit/{Id:int}"

@using Models.CompetitionData
@using Business.Repository.IRepository
@inject NavigationManager NavigationManager
@inject IJSRuntime JsRuntime
@inject ICompetitionParentRepository CompetitionParentRepository
@inject Blazored.LocalStorage.ILocalStorageService localStorage

<div class="row mt-2 mb-5">
    <h3 class="card-title text-info mb-3 ml-3">@Title League</h3>
    <div class="col-md-12">
        <div class="card">
            <div class="card-body">
                <EditForm Model="@CompetitionParentModel" OnValidSubmit="HandleCreateUpdate">
                    <DataAnnotationsValidator />
                    @*<ValidationSummary />*@
                    <div class="form-group">
                        <label>Season</label>
                        <InputText @bind-Value="currentSeason" class="form-control" disabled="true"></InputText>
                    </div>
                    <div class="form-group">
                        <label>Name</label>
                        <InputText @bind-Value="CompetitionParentModel.Name" class="form-control"></InputText>
                        <ValidationMessage For="() => CompetitionParentModel.Name" />
                    </div>
                    <div class="form-group">
                        <button class="btn btn-primary">@Title league </button>
                        <NavLink href="competitionParents" class="btn btn-secondary">Back to Index</NavLink>
                    </div>
                </EditForm>
            </div>
        </div>
    </div>
</div>



@code {

    [Parameter]
    public int? Id { get; set; }
    private CompetitionParentDTO CompetitionParentModel { get; set; } = new CompetitionParentDTO();
    private string currentSeason { get; set; }
    private string Title { get; set; } = "Create";
    protected override async Task OnInitializedAsync()
    {
        if (Id != null)
        {
            //update
            Title = "Update";
            CompetitionParentModel = await CompetitionParentRepository.Get(Id.Value);
        }
        else
        {
            //create
            CompetitionParentModel = new CompetitionParentDTO();
        }
        currentSeason = await localStorage.GetItemAsync<string>("seasonName");
    }
    private async Task HandleCreateUpdate()
    {
        try
        {
            // add check if competitionParent is unique
            // --
            // --
            if (CompetitionParentModel.Id != 0 && Title == "Update")
            {
                //update
                var updateCompetitionParent = await CompetitionParentRepository.Update(CompetitionParentModel, CompetitionParentModel.Id);
                await JsRuntime.ToastrSuccess("CompetitionParent updated successfully");
                await Task.Delay(300);
                NavigationManager.NavigateTo("/competitionParents", true);

            }
            else
            {
                //create
                CompetitionParentModel.SeasonId = await localStorage.GetItemAsync<int>("seasonId");
                var createdResult = await CompetitionParentRepository.Create(CompetitionParentModel);

                await JsRuntime.ToastrSuccess("CompetitionParent created successfully");
                await Task.Delay(300);
                NavigationManager.NavigateTo("/competitionParents", true);
            }
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
}
